Page MenuHome

MacOS user permissions: Blender works only in one user account
Needs Information from Developers, NormalPublicBUG

Description

System Information
Operating system: MacOS High Sierra and Catalina
Graphics card:

Blender Version
Broken: (example: 2.80, edbf15d3c044, master, 2018-11-28, as found on the splash screen)
Worked: (optional)

Short description of error
Since Blender 2.80 I have an issue with MacOS user permissions.
After installing Blender as admin user, it is not possible to open it in other user accounts.
It doesn't matter in which account I install it, it always works only in this account and in no other account.
I tried it on various Macs with various systems (from High Sierra to actual Catalina) and with Blender 2.80, 2.81 and 2.82 Alpha,
in all cases with the same problem. Even if I change the user permissions vor everybody to "Read", it is not possible to open it for other users.
Until 2.79 it was possible to drag&drop Blender into the Application folder and every user on the Mac could open it without problems.

Exact steps for others to reproduce the error
Based on the default startup or an attached .blend file (as simple as possible).

Event Timeline

Hi, can you start blender from command line and see what the error is ?
Maybe https://developer.blender.org/paste/ the log from your admin and non admin account.

Hi! I noticed a strange thing just now. When I put Blender into the application folder (doesn't matter whether in admin account or not), then I can open it in this account
and I can do this without error also from the Terminal. So far, so good.
But if I switch to another user account and try to show the package contents of Blender a totally empty folder will be shown!!
This is ridiculous because it's the same Blender folder from the Application folder.

can you please provide the info I asked above and also https://developer.blender.org/paste/ the output of ls -al /Applications/Blender* ?

Yes, I have pasted the info now.

Ok. You can then mention it here like that: P1193

Quickfix in the terminal execute:
find /Applications/Blender.app -exec chmod 755 {} \;

Campbell Barton (campbellbarton) changed the task status from Unknown Status to Archived.Dec 23 2019, 8:06 AM

@Campbell Barton (campbellbarton) why was this issue closed? There is even a patch for the problem?

Campbell Barton (campbellbarton) reopened this task as Confirmed.EditedDec 23 2019, 10:03 PM

I saw running a local command on the users system fixed the issue and assumed it was a local permissions issue (users sometimes manage to mess up their own permissions) re-opening.

Bastien Montagne (mont29) changed the subtype of this task from "Report" to "Bug".Jan 15 2020, 11:23 AM

Please can this be re-opened. It isn't fixed, this issue means my kids can't use Blender 2.8x without an adult doing the workaround. All previous versions worked fine.

@Simon Bursey (Bigbigsimon) Please open a new report and mention this report in it.

@Campbell Barton (campbellbarton) this isn't fixed. I have the same issue. I installed 2.8.4 by simply drag and drop from the opened dmg file into the /Application folder.. I can open it fine in my user, but my son is not able to open it in his user.

Here's the GetInfo on the Blender.app both within he dmg file and after I copy it to the /Application folder:
The access for "everyone" is NO ACCESS.

Also, by changing the access for everyone to "Read Only" or "Read & Write" directly in the GetInfo window does not seem to fix the problem either. My guess is that every file within the Blender.app folder structure would have to have these permissions set so that the group (e.g. staff/wheel) or even everyone would have at least the read and execute permission set (e.g rwx r-x r-x maybe?).

I could try to do a chmod 755 -R Blender.app to set permissions to read/execute to all files and folders in the app, though I'm not sure if this is the right solution. Perhaps setting the group for all folders/files to a generic group like staff/wheel would be better? I feel like these permissions should have been set appropriately by you guys when you deploy the mac version so that all permissions are set correctly when copying the application from dmg to the Application folder.

Also.. one minor esthetic thing.. can the dmg installer get a little TLC to make it look a little bit more polished? :) Here's a comparison between Blender's and firefox/minecraft dmg installers.

Ankit Meel (ankitm) reopened this task as Needs Information from Developers.Aug 28 2020, 8:53 PM
Ankit Meel (ankitm) removed Campbell Barton (campbellbarton) as the assignee of this task.

This bug persits still and is quite annoying. Here is some techinical information that might help. I have tested Blender 2.83 LTS and Blender 2.90.1 on MacOS Catalina 10.15.7, installed either directly via the downloaded DMG or through Homebrew (which just downloads the DMG anyway).

When Blender is installed, the permissions on /Applications/Blender.app are set to drwx------, i.e., only accessible by the owner, and the owner is the username under which the application was installed. This prevents other users from accessing the application.

As far as I can tell the culprit is the DMG installation file that is available on the Blender web site, because that one already has the Blender.app folder with permissions set to drwx------. When the folder is dragged to /Applications it just inherits the bad permissions. Therefore, the problem cannot be blamed on users, as was suggested by @Campbell Barton (campbellbarton) above.

The quick fix suggested by @Jean First (robbott) above is wrong because it sets all files to the same mode (makes them all executable). A better quick fix is this:

sudo find /Applications/Blender.app -type d -exec chmod a+rx {} \;
sudo find /Applications/Blender.app -type f -exec chmod a+r {} \;
sudo chmod a+x `find /Applications/Blender.app -perm +100 -type f`

The real fix should be quite easy: whatever script or process is used to generate the MacOS DMG install file should be changed to make sure that the file permissions are correct. Someone on the development team probably knows who is in charge of generating the DMG file.

I want to start by saying I love Blender & appreciate all the hard work the development team puts in. Thank you!

That said, this is still a problem with Catalina & 2.91.0. Maybe it's not a big deal if you are only dealing with 1 or 2 computers - or if you are the computer's only user. However, in a computer lab or school, this is super inconvenient. Last year, I could have students update their own computer & I would just need to add my password to complete the installation. It worked for everyone & saved me so much time. Now I need to login myself to 25 different computers to use Terminal to fix the permissions. Please fix this soon.

@Brecht Van Lommel (brecht) , do you know if this is fixed in 2.93?

I'm having the same issue with the 2.92 dmg, which looks to be the latest available build.

I can see the current bundle.sh shows -mode 755 but doesn't include the -uid 0 -gid 0 parameters from this commit.

I don't know anything about hdiutil and creating disk images to know if this is necessary.

@Andrej Bauer (andrejbauer) 's work around did seem to get me to a usable state.